#include"indi.h"
#include"calc.h"
#include"mouse.h"
#include"screen.h"


extern calculator calc;
extern mouse ms;

indicator::indicator()
{
 refresh();
}

void indicator::off()
{
 ms.off();
 int i;
 for(i=0;i<12;i++)
  symbol(i,15,0);
 ms.on();
}

void indicator::refresh()
{
 ms.off();
 symbol(0,0,0);
 int i,t;
 if(calc.ERROR)// ᮢ 
 {
  symbol(1,14,0);
  symbol(2,13,0);
  symbol(3,13,0);
  symbol(4,0,0);
  symbol(5,13,0);
  for(i=6;i<12;i++)
   symbol(i,16,0);
  calc.dig=0;
 }
 else if(calc.PRG)// ᮢ ணࠬ
 {
  for(i=0;i<12;i++)
   symbol(i,16,0);
  symbol(11,calc.prgstep%10,0);
  symbol(10,calc.prgstep/10,0);
  for(i=0;i<3;i++)
  {
   t=calc.prgstep-1-i;
   if(t>=0&&t<=104)
   {
    symbol(i*3+1,calc.prog[t]>>4,0);
    symbol(i*3+2,calc.prog[t]&0x0f,0);
   }
  }
 }
 else // ᮢ ᫮
 {
 if(calc.stack[1]<0)symbol(0,8,0);
 for(i=0;i<11;i++)
 {
  symbol(i+1,calc.ind[i],i==calc.point);
 }
 }
 ms.on();
}

void indicator::symbol(int n,int N,int p)//ᨬ N  樨 n  ⮩ p
{
 switch(N)
 {
  case 0:digit(n,1,0,1,1,1,1,1,p);break;      // 饭 
  case 1:digit(n,0,0,0,0,0,1,1,p);break;     //  ⮬,  ᥣ
  case 2:digit(n,1,1,1,0,1,1,0,p);break;     //  
  case 3:digit(n,1,1,1,0,0,1,1,p);break;     // ࠧ 
  case 4:digit(n,0,1,0,1,0,1,1,p);break;     //  ---1---
  case 5:digit(n,1,1,1,1,0,0,1,p);break;     //  |     |
  case 6:digit(n,1,1,1,1,1,0,1,p);break;     //  4     6
  case 7:digit(n,1,0,0,0,0,1,1,p);break;     //  |     |
  case 8:digit(n,1,1,1,1,1,1,1,p);break;     //  ---2---
  case 9:digit(n,1,1,1,1,0,1,1,p);break;     //  |     |
  case 10:digit(n,0,1,0,0,0,0,0,p);break;    //  5     7
  case 11:digit(n,0,0,1,1,1,0,0,p);break;    //  |     |
  case 12:digit(n,1,0,1,1,1,0,0,p);break;    //  ---3---
  case 13:digit(n,1,0,0,1,1,0,0,p);break;    //          8
  case 14:digit(n,1,1,1,1,1,0,0,p);break;
  case 15:digit(n,0,0,0,0,0,0,0,p);break;
  case 16:digit(n,0,0,0,0,0,0,0,p);break;
 }
}

void indicator::digit(char n,char s1,char s2,char s3,char s4,char s5,char s6,char s7,char s8)//s=1-,s=0-
{
 extern screen scr;
 static DY=37,br=18;
 if(n!=0&&n!=9)
 {
  setcolor(71+s4*br);
  line(scr.DX+15+n*16,DY+3,scr.DX+15+n*16,DY+12);
  line(scr.DX+16+n*16,DY+2,scr.DX+16+n*16,DY+13);
  line(scr.DX+17+n*16,DY+3,scr.DX+17+n*16,DY+12);
  setcolor(71+s5*br);
  line(scr.DX+15+n*16,DY+16,scr.DX+15+n*16,DY+25);
  line(scr.DX+16+n*16,DY+15,scr.DX+16+n*16,DY+26);
  line(scr.DX+17+n*16,DY+16,scr.DX+17+n*16,DY+25);
  setcolor(71+s6*br);
  line(scr.DX+24+n*16,DY+3,scr.DX+24+n*16,DY+12);
  line(scr.DX+25+n*16,DY+2,scr.DX+25+n*16,DY+13);
  line(scr.DX+26+n*16,DY+3,scr.DX+26+n*16,DY+12);
  setcolor(71+s7*br);
  line(scr.DX+24+n*16,DY+16,scr.DX+24+n*16,DY+25);
  line(scr.DX+25+n*16,DY+15,scr.DX+25+n*16,DY+26);
  line(scr.DX+26+n*16,DY+16,scr.DX+26+n*16,DY+25);
  setcolor(71+s1*br);
  line(scr.DX+18+n*16,DY,scr.DX+23+n*16,DY);
  line(scr.DX+17+n*16,DY+1,scr.DX+24+n*16,DY+1);
  line(scr.DX+18+n*16,DY+2,scr.DX+23+n*16,DY+2);
  setcolor(71+s3*br);
  line(scr.DX+18+n*16,DY+26,scr.DX+23+n*16,DY+26);
  line(scr.DX+17+n*16,DY+27,scr.DX+24+n*16,DY+27);
  line(scr.DX+18+n*16,DY+28,scr.DX+23+n*16,DY+28);
 }
  setcolor(71+s2*br);
  line(scr.DX+18+n*16,DY+13,scr.DX+23+n*16,DY+13);
  line(scr.DX+17+n*16,DY+14,scr.DX+24+n*16,DY+14);
  line(scr.DX+18+n*16,DY+15,scr.DX+23+n*16,DY+15);
  setcolor(71+s8*20);
  line(scr.DX+27+n*16,DY+28,scr.DX+27+n*16,DY+32);
  line(scr.DX+28+n*16,DY+27,scr.DX+28+n*16,DY+31);
  line(scr.DX+29+n*16,DY+28,scr.DX+29+n*16,DY+30);
}

