#include"memmenu.h"
#include"calc.h"
#include"mouse.h"
#include"indi.h"

extern calculator calc;
extern mouse ms;
extern indicator indi;

//mem_menu-------------------------------------

mem_menu::mem_menu()
{
 strcpy(name,"");
 wide=strlen(name)*8;
 hpos=pos+48;
 active=1;
 T.set(pos+22,29,pos+262,45,&calc.stack[4],2);
 Z.set(pos+22,46,pos+262,62,&calc.stack[3],2);
 Y.set(pos+22,62,pos+262,79,&calc.stack[2],2);
 X.set(pos+22,80,pos+262,96,&calc.stack[1],2);
 X1.set(pos+32,99,pos+152,107,&calc.stack[0]);
 Fl.set("F",217,&calc.F);
 Fl.setpos(pos+385,14,pos+395,24);
 Kl.set("K",121,&calc.K);
 Kl.setpos(pos+398,14,pos+408,24);
 PRG.set("","",237,&calc.PRG);
 PRG.setpos(pos+356,14,pos+382,24);
 int i;
 for(i=0;i<15;i++)
	MEM[i].set(pos+22,125+i*10,pos+142,134+i*10,&calc.mem[i]);
 EDIT.setpos(pos+200,115,pos+368,375);
 EDIT.init();
 PUP.set("");
 PDOWN.set("");
 PUP.setpos(pos+369,115,pos+383,244);
 PDOWN.setpos(pos+369,245,pos+383,375);
 open();
}

void mem_menu::open()
{
 clear();
 head(1);
 ms.off();
 settextstyle(0,0,0);
 setcolor(120);
 settextjustify(0,2);
 outtextxy(pos+22,20,"⥪:");
 outtextxy(pos+12,34,"T");
 outtextxy(pos+12,51,"Z");
 outtextxy(pos+12,68,"Y");
 outtextxy(pos+12,85,"X");
 outtextxy(pos+12,100,"X1");
 outtextxy(pos+22,115,":");
 outtextxy(pos+202,105,"ணࠬ:");
 int i;
 char str[5];
 for(i=0;i<15;i++)
  {
   itoa(i,str,16);
   outtextxy(pos+12,127+i*10,str);
  }
 for(i=0;i<15;i++)
  MEM[i].open();
 T.open();
 Z.open();
 Y.open();
 X.open();
 X1.open();
 Fl.open();
 Kl.open();
 PRG.open();
 EDIT.open();
 PUP.open();
 PDOWN.open();
 ms.on();
 refresh();
}

void mem_menu::refresh()
{
 ms.off();
 X.refresh();
 Y.refresh();
 Z.refresh();
 T.refresh();
 X1.refresh();
 Fl.refresh();
 Kl.refresh();
 PRG.refresh();
 int i;
 for(i=0;i<15;i++)
	MEM[i].refresh();
 EDIT.refresh();
 PUP.refresh();
 PDOWN.refresh();
 ms.on();
}

void mem_menu::click()
{
 if(PUP.pressed())EDIT.up();
 if(PDOWN.pressed())EDIT.down();
 EDIT.click();
}

// ।(?) ணࠬ

prgedit::prgedit()
{
 begin=0;
 nline=14;//<<<<<<<
}

void prgedit::edit()
{
 int i;
	i=(menu::my-y0-3)/17;
 if(!calc.RUN&&calc.prgstep!=begin+i)
 {
 calc.prgstep=begin+i;
 show();
 paint(1);
 indi.refresh();
 }
}

void prgedit::up()
{
 begin-=7;
 if(begin<0)begin=0;
 show();
 paint(1);
}

void prgedit::down()
{
 begin+=7;
 if(begin+nline>104)begin=104-nline;
 show();
 paint(1);
}

extern unsigned char BUTT[6][5][420];
extern unsigned char YELL[4][5][139];
extern unsigned char BLUE1[3][139];
extern unsigned char BLUE2[4][139];
extern unsigned char BLUE3[3][139];
extern unsigned char BLUE4[5][139];
extern unsigned char LETT[5][40];
extern unsigned char JUMP[4][184];
extern unsigned char LOOP[4][139];

void prgedit::paint(int mode)
{
 int i,jmp,tmp,ncom,com,ypos;
 char str[16];
 if(!mode)// ᮢ, ⮡ ⥪ ப 뫠 
 {
	begin=calc.prgstep-7;
	if(begin<0)begin=0;
	else if(begin+nline>104)begin=104-nline;
 }
 //㥬
 ms.off();
 if(((tmp=calc.prog[begin-1])==0x51||(tmp>=0x57&&tmp<=0x5e)||tmp==0x53)&&begin!=0)
	jmp=1;
 else jmp=0; //   ᥣ  ।,   ࢠ ப
 settextjustify(0,2);
 settextstyle(0,0,0);
 setcolor(10);//<<<<<<
 for(i=0;i<=nline;i++)
 {
	ncom=begin+i;
	com=calc.prog[ncom];
	ypos=y0+3+i*17;
	if(ncom==calc.prgstep)//뤥塞 ⥪
	{
	 outtextxy(x0+4,ypos+4,"\x10");
	 outtextxy(x0+155,ypos+4,"\x11");
	}
	sprintf(str,"%02i",ncom);
	outtextxy(x0+20,ypos+4,str);
	sprintf(str,"%02X",com);
	outtextxy(x0+134,ypos+4,str);
	if(jmp)//᫨  ᮢ  室
	{
	 num(com>>4,x0+48,ypos);
	 num(com%16,x0+75,ypos);
	 jmp=0;
	}
	else//
	switch(com)//ᨢ ⨭
	{
	 case 0x00:putimage(x0+48,ypos,BUTT[5][0],0);break;
	 case 0x01:putimage(x0+48,ypos,BUTT[4][0],0);break;
	 case 0x02:putimage(x0+48,ypos,BUTT[4][1],0);break;
	 case 0x03:putimage(x0+48,ypos,BUTT[4][2],0);break;
	 case 0x04:putimage(x0+48,ypos,BUTT[3][0],0);break;
	 case 0x05:putimage(x0+48,ypos,BUTT[3][1],0);break;
	 case 0x06:putimage(x0+48,ypos,BUTT[3][2],0);break;
	 case 0x07:putimage(x0+48,ypos,BUTT[2][0],0);break;
	 case 0x08:putimage(x0+48,ypos,BUTT[2][1],0);break;
	 case 0x09:putimage(x0+48,ypos,BUTT[2][2],0);break;
	 case 0x0a:putimage(x0+48,ypos,BUTT[5][1],0);break;
	 case 0x0b:putimage(x0+48,ypos,BUTT[5][2],0);break;
	 case 0x0c:putimage(x0+48,ypos,BUTT[5][3],0);break;
	 case 0x0d:putimage(x0+48,ypos,BUTT[5][4],0);break;
	 case 0x0e:putimage(x0+48,ypos,BUTT[4][4],0);break;
	 case 0x0f:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+80,ypos+4,YELL[2][4],0);break;
	 case 0x10:putimage(x0+48,ypos,BUTT[3][3],0);break;
	 case 0x11:putimage(x0+48,ypos,BUTT[2][3],0);break;
	 case 0x12:putimage(x0+48,ypos,BUTT[3][4],0);break;
	 case 0x13:putimage(x0+48,ypos,BUTT[2][4],0);break;
	 case 0x14:putimage(x0+48,ypos,BUTT[4][3],0);break;
	 case 0x15:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+80,ypos+4,YELL[3][0],0);break;
	 case 0x16:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+80,ypos+4,YELL[2][0],0);break;
	 case 0x17:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+80,ypos+4,YELL[2][1],0);break;
	 case 0x18:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+80,ypos+4,YELL[2][2],0);break;
	 case 0x19:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+80,ypos+4,YELL[1][0],0);break;
	 case 0x1a:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+80,ypos+4,YELL[1][1],0);break;
	 case 0x1b:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+80,ypos+4,YELL[1][2],0);break;
	 case 0x1c:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+80,ypos+4,YELL[0][0],0);break;
	 case 0x1d:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+80,ypos+4,YELL[0][1],0);break;
	 case 0x1e:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+80,ypos+4,YELL[0][2],0);break;
	 case 0x20:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+80,ypos+4,YELL[1][3],0);break;
	 case 0x21:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+80,ypos+4,YELL[0][3],0);break;
	 case 0x22:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+80,ypos+4,YELL[1][4],0);break;
	 case 0x23:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+80,ypos+4,YELL[0][4],0);break;
	 case 0x24:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+80,ypos+4,YELL[2][3],0);break;
	 case 0x25:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+80,ypos+4,YELL[3][1],0);break;
	 case 0x26:putimage(x0+48,ypos,BUTT[1][0],0);putimage(x0+80,ypos+4,BLUE2[3],0);break;
	 case 0x2a:putimage(x0+48,ypos,BUTT[1][0],0);putimage(x0+80,ypos+4,BLUE3[0],0);break;
	 case 0x30:putimage(x0+48,ypos,BUTT[1][0],0);putimage(x0+80,ypos+4,BLUE3[1],0);break;
	 case 0x31:putimage(x0+48,ypos,BUTT[1][0],0);putimage(x0+80,ypos+4,BLUE2[0],0);break;
	 case 0x32:putimage(x0+48,ypos,BUTT[1][0],0);putimage(x0+80,ypos+4,BLUE2[1],0);break;
	 case 0x33:putimage(x0+48,ypos,BUTT[1][0],0);putimage(x0+80,ypos+4,BLUE2[2],0);break;
	 case 0x34:putimage(x0+48,ypos,BUTT[1][0],0);putimage(x0+80,ypos+4,BLUE1[0],0);break;
	 case 0x35:putimage(x0+48,ypos,BUTT[1][0],0);putimage(x0+80,ypos+4,BLUE1[1],0);break;
	 case 0x36:putimage(x0+48,ypos,BUTT[1][0],0);putimage(x0+80,ypos+4,BLUE1[2],0);break;
	 case 0x37:putimage(x0+48,ypos,BUTT[1][0],0);putimage(x0+80,ypos+4,BLUE4[1],0);break;
	 case 0x38:putimage(x0+48,ypos,BUTT[1][0],0);putimage(x0+80,ypos+4,BLUE4[2],0);break;
	 case 0x39:putimage(x0+48,ypos,BUTT[1][0],0);putimage(x0+80,ypos+4,BLUE4[3],0);break;
	 case 0x3a:putimage(x0+48,ypos,BUTT[1][0],0);putimage(x0+80,ypos+4,BLUE4[4],0);break;
	 case 0x3b:putimage(x0+48,ypos,BUTT[1][0],0);putimage(x0+80,ypos+4,BLUE3[2],0);break;
	 case 0x40:
	 case 0x41:
	 case 0x42:
	 case 0x43:
	 case 0x44:
	 case 0x45:
	 case 0x46:
	 case 0x47:
	 case 0x48:
	 case 0x49:
	 case 0x4a:
	 case 0x4b:
	 case 0x4c:
	 case 0x4d:
	 case 0x4e:
						putimage(x0+48,ypos,BUTT[1][2],0);
						num(com%16,x0+75,ypos);
	 break;
	 case 0x50:putimage(x0+48,ypos,BUTT[0][4],0);break;
	 case 0x51:putimage(x0+48,ypos,BUTT[1][3],0);jmp=1;break;
	 case 0x52:putimage(x0+48,ypos,BUTT[0][3],0);break;
	 case 0x53:putimage(x0+48,ypos,BUTT[1][4],0);jmp=1;break;
	 case 0x54:putimage(x0+48,ypos,BUTT[1][0],0);putimage(x0+80,ypos+4,BLUE4[0],0);break;
	 case 0x57:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+78,ypos+4,JUMP[3],0);jmp=1;break;
	 case 0x58:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+80,ypos+4,LOOP[2],0);jmp=1;break;
	 case 0x59:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+78,ypos+4,JUMP[2],0);jmp=1;break;
	 case 0x5a:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+80,ypos+4,LOOP[3],0);jmp=1;break;
	 case 0x5b:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+80,ypos+4,LOOP[1],0);jmp=1;break;
	 case 0x5c:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+78,ypos+4,JUMP[0],0);jmp=1;break;
	 case 0x5d:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+80,ypos+4,LOOP[0],0);jmp=1;break;
	 case 0x5e:putimage(x0+48,ypos,BUTT[0][0],0);putimage(x0+78,ypos+4,JUMP[1],0);jmp=1;break;
	 case 0x60:
	 case 0x61:
	 case 0x62:
	 case 0x63:
	 case 0x64:
	 case 0x65:
	 case 0x66:
	 case 0x67:
	 case 0x68:
	 case 0x69:
	 case 0x6a:
	 case 0x6b:
	 case 0x6c:
	 case 0x6d:
	 case 0x6e:
						putimage(x0+48,ypos,BUTT[1][1],0);
						num(com%16,x0+75,ypos);
	 break;
	 case 0x70:
	 case 0x71:
	 case 0x72:
	 case 0x73:
	 case 0x74:
	 case 0x75:
	 case 0x76:
	 case 0x77:
	 case 0x78:
	 case 0x79:
	 case 0x7a:
	 case 0x7b:
	 case 0x7c:
	 case 0x7d:
	 case 0x7e:
						putimage(x0+48,ypos,BUTT[1][0],0);
						putimage(x0+78,ypos+4,JUMP[3],0);
						num(com%16,x0+102,ypos);
	 break;
	 case 0x80:
	 case 0x81:
	 case 0x82:
	 case 0x83:
	 case 0x84:
	 case 0x85:
	 case 0x86:
	 case 0x87:
	 case 0x88:
	 case 0x89:
	 case 0x8a:
	 case 0x8b:
	 case 0x8c:
	 case 0x8d:
	 case 0x8e:
						putimage(x0+48,ypos,BUTT[1][0],0);
						putimage(x0+75,ypos,BUTT[1][3],0);
						num(com%16,x0+102,ypos);
	 break;
	 case 0x90:
	 case 0x91:
	 case 0x92:
	 case 0x93:
	 case 0x94:
	 case 0x95:
	 case 0x96:
	 case 0x97:
	 case 0x98:
	 case 0x99:
	 case 0x9a:
	 case 0x9b:
	 case 0x9c:
	 case 0x9d:
	 case 0x9e:
						putimage(x0+48,ypos,BUTT[1][0],0);
						putimage(x0+78,ypos+4,JUMP[2],0);
						num(com%16,x0+102,ypos);
	 break;
	 case 0xa0:
	 case 0xa1:
	 case 0xa2:
	 case 0xa3:
	 case 0xa4:
	 case 0xa5:
	 case 0xa6:
	 case 0xa7:
	 case 0xa8:
	 case 0xa9:
	 case 0xaa:
	 case 0xab:
	 case 0xac:
	 case 0xad:
	 case 0xae:
						putimage(x0+48,ypos,BUTT[1][0],0);
						putimage(x0+75,ypos,BUTT[1][4],0);
						num(com%16,x0+102,ypos);
	 break;
	 case 0xb0:
	 case 0xb1:
	 case 0xb2:
	 case 0xb3:
	 case 0xb4:
	 case 0xb5:
	 case 0xb6:
	 case 0xb7:
	 case 0xb8:
	 case 0xb9:
	 case 0xba:
	 case 0xbb:
	 case 0xbc:
	 case 0xbd:
	 case 0xbe:
						putimage(x0+48,ypos,BUTT[1][0],0);
						putimage(x0+75,ypos,BUTT[1][2],0);
						num(com%16,x0+102,ypos);
	 break;
	 case 0xc0:
	 case 0xc1:
	 case 0xc2:
	 case 0xc3:
	 case 0xc4:
	 case 0xc5:
	 case 0xc6:
	 case 0xc7:
	 case 0xc8:
	 case 0xc9:
	 case 0xca:
	 case 0xcb:
	 case 0xcc:
	 case 0xcd:
	 case 0xce:
						putimage(x0+48,ypos,BUTT[1][0],0);
						putimage(x0+78,ypos+4,JUMP[0],0);
						num(com%16,x0+102,ypos);
	 break;
	 case 0xd0:
	 case 0xd1:
	 case 0xd2:
	 case 0xd3:
	 case 0xd4:
	 case 0xd5:
	 case 0xd6:
	 case 0xd7:
	 case 0xd8:
	 case 0xd9:
	 case 0xda:
	 case 0xdb:
	 case 0xdc:
	 case 0xdd:
	 case 0xde:
						putimage(x0+48,ypos,BUTT[1][0],0);
						putimage(x0+75,ypos,BUTT[1][1],0);
						num(com%16,x0+102,ypos);
	 break;
	 case 0xe0:
	 case 0xe1:
	 case 0xe2:
	 case 0xe3:
	 case 0xe4:
	 case 0xe5:
	 case 0xe6:
	 case 0xe7:
	 case 0xe8:
	 case 0xe9:
	 case 0xea:
	 case 0xeb:
	 case 0xec:
	 case 0xed:
	 case 0xee:
						putimage(x0+48,ypos,BUTT[1][0],0);
						putimage(x0+78,ypos+4,JUMP[1],0);
						num(com%16,x0+102,ypos);
	 break;
	}
 }
 ms.on();
}

void prgedit::num(int n,int x,int y)
{
 switch(n)
 {
	case 0:putimage(x,y,BUTT[5][0],0);break;
	case 1:putimage(x,y,BUTT[4][0],0);break;
	case 2:putimage(x,y,BUTT[4][1],0);break;
	case 3:putimage(x,y,BUTT[4][2],0);break;
	case 4:putimage(x,y,BUTT[3][0],0);break;
	case 5:putimage(x,y,BUTT[3][1],0);break;
	case 6:putimage(x,y,BUTT[3][2],0);break;
	case 7:putimage(x,y,BUTT[2][0],0);break;
	case 8:putimage(x,y,BUTT[2][1],0);break;
	case 9:putimage(x,y,BUTT[2][2],0);break;
	case 10:putimage(x+10,y+3,LETT[0],2);break;
	case 11:putimage(x+10,y+3,LETT[1],2);break;
	case 12:putimage(x+10,y+3,LETT[2],2);break;
	case 13:putimage(x+10,y+3,LETT[3],2);break;
	case 14:putimage(x+10,y+3,LETT[4],2);break;
 }
}
