#include"menu.h"
#include"mouse.h"
#include"calc.h"
#include"indi.h"
#include"filemenu.h"
#include"memmenu.h"
//#include"optsmenu.h"
#include"helpmenu.h"
//#include"miscmenu.h"
#include"keys.h"

//ॠ  ( ⥡)

extern mouse ms;
extern file_menu fmenu;
extern mem_menu mmenu;
//extern opts_menu omenu;
extern help_menu hmenu;
//extern misc_menu msmenu;
extern calculator calc;
extern indicator indi;
extern keyboard keys;

const char  //梥
 bkcol=12,
 bdcol=31,
 txtcol=120;
const int DY=11;

//class menu
int menu::pos;
int menu::mx;
int menu::my;

menu::menu()
{
 pos=0;
 mx=0;
 my=0;
 fresh=1;
}

void menu::clear()
{
 setfillstyle(1,bkcol);
 setcolor(bdcol);
 ms.off();
 bar(pos+10,DY+1,pos+410,478);
 rectangle(pos+9,DY,pos+411,479);
 ms.on();
}

void menu::head(int flag)
{
 int pts[8];
 pts[0]=hpos;pts[1]=DY;
 pts[2]=hpos+2;pts[3]=0;
 pts[4]=pts[2]+wide;pts[5]=0;
 pts[6]=pts[4]+2;pts[7]=DY;
 ms.off();
 setcolor(bdcol-!flag*10);
 setfillstyle(1,bkcol);
 fillpoly(4,pts);
 if(flag)setcolor(bkcol);
 else setcolor(bdcol);
 line(hpos,DY,hpos+4+wide,DY);
 setcolor(txtcol-!flag*10);
 settextstyle(0,0,0);
 settextjustify(1,1);
 outtextxy(hpos+2+wide/2,DY/2+1,name);
 ms.on();
}

void menu::check()
{
 if(active)
 {
 //if(fresh){refresh();fresh=0;}
 if(ms.butt())
 {
  mx=ms.x();
  my=ms.y();
	if(my>0&&my<DY)   //  ४祭  
  {
   if(mx>fmenu.hpos&&mx<(fmenu.hpos+fmenu.wide)&&!fmenu.active)
   {
   close();
   active=0;
   fmenu.open();
   fmenu.active=1;
   }
   else if(mx>mmenu.hpos&&mx<(mmenu.hpos+mmenu.wide)&&!mmenu.active)
   {
   close();
   active=0;
   mmenu.open();
   mmenu.active=1;
   }
   /*else if(mx>omenu.hpos&&mx<(omenu.hpos+omenu.wide)&&!omenu.active)
   {
   close();
   active=0;
   omenu.open();
   omenu.active=1;
   } */
   else if(mx>hmenu.hpos&&mx<(hmenu.hpos+hmenu.wide)&&!hmenu.active)
   {
   close();
   active=0;
   hmenu.open();
   hmenu.active=1;
   }
   /*else if(mx>msmenu.hpos&&mx<(msmenu.hpos+msmenu.wide)&&!msmenu.active)
   {
   close();
   active=0;
   msmenu.open();
	 msmenu.active=1;
   } */
  }
  else if(mx<pos+411&&mx>pos)//⨢ ॠ 
  {
   click();
  }
 }
  else if(fresh)// ᮢ, ᫨  
  {
   refresh();
   fresh=0;
  }
 }
}

/*void menu::close(int n)
{
 switch(n)
 {
  case 0:fmenu.close();break;
  case 1:mmenu.close();break;
  case 2:omenu.close();break;
  case 3:hmenu.close();break;
	case 4:msmenu.close();break;
 }
} */

void menu::close()
{
 head(0);
}

// -----------------------------------

void form::close()
{
 setfillstyle(1,bkcol);
 bar(x0,y0,x1,y1);
}

void form::setpos(int X0,int Y0,int X1,int Y1)
{
 x0=X0;
 y0=Y0;
 x1=X1;
 y1=Y1;
}

const char vbkcol=40,
           vtxtcol=240;//<-------

void form::open()
{
 ms.off();
 setfillstyle(1,vbkcol);
 setcolor(bdcol);
 bar(x0,y0,x1,y1);
 rectangle(x0,y0,x1,y1);
 ms.on();
 fresh=1;
}

void viewer::set(int X0,int Y0,int X1,int Y1,double* NUM,int S)
{
 setpos(X0,Y0,X1,Y1);
 num=NUM;
 size=S;
}

void viewer::refresh()
{
 if(fresh)
 {
 open();
 char str[20];
 sprintf(str,"%15.8G",*num);
 setcolor(vtxtcol);
 settextstyle(0,0,size);
 settextjustify(0,2);
 outtextxy(x0+1,y0+1,str);
 fresh=0;
 }
}



void light::set(char* txt,char c,int* p)
{
 strcpy(text,txt);
 col=c;
 on=p;
}

void light::refresh()
{
 if(fresh)
 {
 if(on&&*on) setcolor(col);
 else setcolor(col-10);
 settextstyle(0,0,0);
 settextjustify(0,2);
 outtextxy(x0+2,y0+2,text);
 fresh=0;
 }
}

void advlight::set(char* txt,char* txt2,char col,int* p)
{
 light::set(txt,col,p);
 strcpy(text2,txt2);
}

void advlight::refresh()
{
 if(fresh)
 {
 open();
 setcolor(col);
 settextstyle(0,0,0);
 settextjustify(0,2);
 if(on&&*on) outtextxy(x0+2,y0+2,text);
 else outtextxy(x0+2,y0+2,text2);
 fresh=0;
 }
}

//
const char btcol=105,
           btbor=25,
					 bttxt=180;

void button::show(int flag)
{
 if(fresh)
 {
 ms.off();
 setcolor(clrcol);
 line(x0,y0+1,x0,y1);
 line(x0,y1,x1-2,y1);
 setcolor(btbor);
 setfillstyle(1,btcol);
 bar3d(x0+flag,y0+1-flag,x1-2+flag,y1-flag,2-flag,1);
 settextjustify(1,1);
 settextstyle(0,0,0);
 setcolor(bttxt);
 outtextxy(((x1+x0)>>1)+flag-2,((y0+y1)>>1)-flag+1,text);
 ms.on();
 fresh=0;
 }
}

void button::open()
{
 fresh=1;
 show(0);
}

int button::pressed()
{
 if(menu::my<y1&&menu::my>y0&&menu::mx>x0&&menu::mx<x1)
 {
  if(press!=1)
  {
   press=1;
   fresh=1;
	 show(1);
	 if(fmenu.active)fmenu.fresh=1;  //???
	 else if(mmenu.active)mmenu.fresh=1;
	 //else if(omenu.active)omenu.fresh=1;
	 else if(hmenu.active)hmenu.fresh=1;
	 //else if(msmenu.active)msmenu.fresh=1;
	 return(1);
  }
 }
 return(0);
}

void button::refresh()
{
 if(press!=0)
 {
  press=0;
  fresh=1;
  show(0);
 }
}

void button::set(char *txt,char ccol)
{
 strcpy(text,txt);
 clrcol=ccol;
}

void button::init()
{
 x0=y0=x1=y1=0;
 press=0;
}

//直 ࠧ ।
const edcol=224,
      edbor=20;

editor::editor()
{

}

void editor::init()
{

}

void editor::open()
{
 show();
 paint(1);
}

void editor::click()
{
 if(menu::mx>x0&&menu::mx<x1&&menu::my>y0&&menu::my<y1)edit();
}

void editor::refresh()
{
 if(fresh)
 {
 show();
 paint();
 fresh=0;
 }
}

void editor::show()
{
 setcolor(edbor);
 setfillstyle(1,edcol);
 bar(x0,y0,x1,y1);
 rectangle(x0,y0,x1,y1);
}


//ᯨ祪
list::list()
{
 begin=0;
 cur=0;
 N=0;
}

int list::next()
{
 cur=cur->next;
 if(cur)return 1;
 else return 0;
}

void list::reset()
{
 cur=begin;
}

listitem list::get()
{
 listitem L;
 strcpy(L.name,"");
 strcpy(L.date,"");
 if(cur)return(*cur);
 else return L;
}

void list::insert(listitem &I)
{
 listitem *pre=0,*n,*c=begin;
 n=new listitem;//ᮧ  
 strcpy(n->name,I.name);//஢
 strcpy(n->date,I.date);
 while(c!=0&&strcmp(c->name,n->name)<0)
 {
	pre=c;   //  祣  ⠢
	c=c->next;
 }
 n->next=c;//⠢
 if(pre==0)
	begin=n; // 砫
 else
	pre->next=n;// 
 N++;
}

void list::destroy()
{
 listitem *c=begin,*pre=0;
 while(c!=0)//  
 {
	pre=c;
	c=c->next;
	delete pre;// ᭮ᨬ  
 }
 begin=0;//
 N=0;
}

list::~list()
{
 destroy();
}

void textview::set(char *c,int s)
{
 txt=c;
 size=s;
 if(size!=0)
 len=(x1-x0)/(8*size);
 else
 len=(x1-x0)/8;
}

void textview::refresh()
{
 if(fresh)
 {
 open();
 setcolor(vtxtcol);
 settextstyle(0,0,size);
 settextjustify(0,2);
 int tmp;
 tmp=strlen(txt)-len;
 if(tmp<0)tmp=0;
 ms.off();
 outtextxy(x0+2,y0+2,txt+tmp);
 ms.on();
 fresh=0;
 }
}

void textedit::click()
{
 if(menu::mx>x0&&menu::mx<x1&&menu::my>y0&&menu::my<y1)edit();
}

void textedit::edit()
{
 keys.lock();
 ms.off();
 char c;
 txt[0]=0;
 fresh=1;
 refresh();
 int pos=0;
 do
 {
  if(kbhit())
  {
   c=getch();
   if(isalpha(c)||isdigit(c)||c=='_')
   {
    if(pos>=8)break;
    txt[pos]=c;
    txt[pos+1]=0;
    pos++;
   }
   else if(c=='.')
   {
    break;
   }
   else if(c==8)
   {
    pos--;
    if(pos<0)pos=0;
    txt[pos]=0;
   }
   fresh=1;
   refresh();
  }
 }
 while(pos<=8&&c!=13);
 txt[pos]='.';
 txt[pos+1]='M';
 txt[pos+2]='K';
 txt[pos+3]=0;
 fresh=1;
 refresh();
 delay(200);
 ms.on();
 keys.unlock();
}